Re: [RFC PATCH v2 4/5] kbuild: Add generic hook for architectures to use before the final vmlinux link
From: Naveen N Rao <naveen@kernel.org>
Date: 2024-06-12 10:54:21
Subsystem:
kernel build + files below scripts/ (unless maintained elsewhere), linux for powerpc (32-bit and 64-bit), the rest · Maintainers:
Nathan Chancellor, Nicolas Schier, Madhavan Srinivasan, Michael Ellerman, Linus Torvalds
On Tue, Jun 11, 2024 at 11:05:56PM GMT, Naveen N Rao wrote:
quoted hunk ↗ jump to hunk
On Tue, Jun 11, 2024 at 06:51:51AM GMT, Masahiro Yamada wrote:quoted
On Tue, Jun 11, 2024 at 2:20 AM Naveen N Rao [off-list ref] wrote:quoted
On Mon, Jun 10, 2024 at 06:14:51PM GMT, Masahiro Yamada wrote:quoted
On Mon, Jun 10, 2024 at 5:39 PM Naveen N Rao [off-list ref] wrote:quoted
+arch_vmlinux_o="" +if is_enabled CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX; then + arch_vmlinux_o=.arch.vmlinux.o + info "ARCH" ${arch_vmlinux_o} + if ! ${srctree}/arch/${SRCARCH}/tools/vmlinux_o.sh ${arch_vmlinux_o} ; then + echo >&2 "Failed to generate ${arch_vmlinux_o}" + echo >&2 "Try to disable CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX" + exit 1 + fi +fiThis is wrong because scripts/link-vmlinux.sh is not triggered even when source files under arch/powerpc/tools/ are changed. Presumably, scripts/Makefile.vmlinux will be the right place.Ah, yes. Something like this?diff --git a/scripts/Makefile.vmlinux b/scripts/Makefile.vmlinux index 49946cb96844..77d90b6ac53e 100644 --- a/scripts/Makefile.vmlinux +++ b/scripts/Makefile.vmlinux@@ -22,6 +22,10 @@ targets += .vmlinux.export.o vmlinux: .vmlinux.export.o endif +ifdef CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX +vmlinux: $(srctree)/arch/$(SRCARCH)/tools/vmlinux_o.sh +endif + ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(SRCARCH)/Makefile.postlink) # Final link of vmlinux with optional arch pass after final linkThanks, NaveenNo. Something like below. Then, you can do everything in Makefile, not a shell script. ifdef CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX vmlinux: .arch.vmlinux.o .arch.vmlinux.o: FORCE $(Q)$(MAKE) $(build)=arch/$(SRCARCH)/tools .arch.vmlinux.o endif I did not test it, though.Thanks for the pointer. I will try and build on that. Just to be completely sure, does the below incremetal diff on top of the existing patch capture your suggestion? ---diff --git a/scripts/Makefile.vmlinux b/scripts/Makefile.vmlinux index 49946cb96844..04e088d7a1ca 100644 --- a/scripts/Makefile.vmlinux +++ b/scripts/Makefile.vmlinux@@ -22,6 +22,13 @@ targets += .vmlinux.export.o vmlinux: .vmlinux.export.o endif +ifdef CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX +vmlinux: .arch.vmlinux.o + +.arch.vmlinux.o: FORCE + $(Q)$(MAKE) $(build)=arch/$(SRCARCH)/tools .arch.vmlinux.o +endif + ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(SRCARCH)/Makefile.postlink) # Final link of vmlinux with optional arch pass after final linkdiff --git a/scripts/link-vmlinux.sh b/scripts/link-vmlinux.sh index 07f70e105d82..f1b705b8cdca 100755 --- a/scripts/link-vmlinux.sh +++ b/scripts/link-vmlinux.sh@@ -227,12 +227,6 @@ ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o arch_vmlinux_o="" if is_enabled CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX; then arch_vmlinux_o=.arch.vmlinux.o - info "ARCH" ${arch_vmlinux_o} - if ! ${srctree}/arch/${SRCARCH}/tools/vmlinux_o.sh ${arch_vmlinux_o} ; then - echo >&2 "Failed to generate ${arch_vmlinux_o}" - echo >&2 "Try to disable CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX" - exit 1 - fi fi btf_vmlinux_bin_o=""
This is what I ended up with: ---
diff --git a/arch/Kconfig b/arch/Kconfig
index 975dd22a2dbd..649f0903e7ef 100644
--- a/arch/Kconfig
+++ b/arch/Kconfig@@ -1643,4 +1643,7 @@ config CC_HAS_SANE_FUNCTION_ALIGNMENT config ARCH_NEED_CMPXCHG_1_EMU bool +config ARCH_WANTS_PRE_LINK_VMLINUX + def_bool n + endmenu
diff --git a/scripts/Makefile.vmlinux b/scripts/Makefile.vmlinux
index 49946cb96844..6410e0be7f52 100644
--- a/scripts/Makefile.vmlinux
+++ b/scripts/Makefile.vmlinux@@ -22,6 +22,14 @@ targets += .vmlinux.export.o vmlinux: .vmlinux.export.o endif +ifdef CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX +targets += .arch.vmlinux.o +.arch.vmlinux.o: vmlinux.o FORCE + $(Q)$(MAKE) $(build)=arch/$(SRCARCH)/tools .arch.vmlinux.o + +vmlinux: .arch.vmlinux.o +endif + ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(SRCARCH)/Makefile.postlink) # Final link of vmlinux with optional arch pass after final link
diff --git a/scripts/link-vmlinux.sh b/scripts/link-vmlinux.sh
index 46ce5d04dbeb..eb5fb71f5207 100755
--- a/scripts/link-vmlinux.sh
+++ b/scripts/link-vmlinux.sh@@ -122,7 +122,7 @@ gen_btf() return 1 fi - vmlinux_link ${1} + vmlinux_link ${1} ${arch_vmlinux_o} info "BTF" ${2} LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
@@ -178,7 +178,7 @@ kallsyms_step() kallsymso=${kallsyms_vmlinux}.o kallsyms_S=${kallsyms_vmlinux}.S - vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o} + vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o} ${arch_vmlinux_o} mksysmap ${kallsyms_vmlinux} ${kallsyms_vmlinux}.syms kallsyms ${kallsyms_vmlinux}.syms ${kallsyms_S}
@@ -223,6 +223,11 @@ fi ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o +arch_vmlinux_o="" +if is_enabled CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX; then + arch_vmlinux_o=.arch.vmlinux.o +fi + btf_vmlinux_bin_o="" if is_enabled CONFIG_DEBUG_INFO_BTF; then btf_vmlinux_bin_o=.btf.vmlinux.bin.o
@@ -273,7 +278,7 @@ if is_enabled CONFIG_KALLSYMS; then fi fi -vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o} +vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o} ${arch_vmlinux_o} # fill in BTF IDs if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
--- Along with the below Makefile, things seem to be working properly in my limited tests:
diff --git a/arch/powerpc/tools/Makefile b/arch/powerpc/tools/Makefile
new file mode 100644
index 000000000000..9e2ba9a85baa
--- /dev/null
+++ b/arch/powerpc/tools/Makefile@@ -0,0 +1,10 @@ +# SPDX-License-Identifier: GPL-2.0-or-later + +quiet_cmd_gen_ftrace_pfe_stubs = FTRACE $@ + cmd_gen_ftrace_pfe_stubs = $< $(objtree)/vmlinux.o $@ + +targets += .arch.vmlinux.o +.arch.vmlinux.o: $(srctree)/arch/powerpc/tools/gen-ftrace-pfe-stubs.sh $(objtree)/vmlinux.o FORCE + $(call if_changed,gen_ftrace_pfe_stubs) + +clean-files += $(objtree)/.arch.vmlinux.S $(objtree)/.arch.vmlinux.o - Naveen